/*
 * gsampler-device.h
 * Copyright (C) Lilian Monchalin 2011 <isaya07@users.sf.net>
 * 
 * gsampler is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * gsampler is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _GSAMPLER_DEVICE_H_
#define _GSAMPLER_DEVICE_H_

#include <gtk/gtk.h>
#include "gsampler-client-device.h"

G_BEGIN_DECLS

#define GSAMPLER_TYPE_DEVICE (gsampler_device_get_type ())
#define GSAMPLER_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GSAMPLER_TYPE_DEVICE, GsamplerDevice))
#define GSAMPLER_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GSAMPLER_TYPE_DEVICE, GsamplerDeviceClass))
#define GSAMPLER_IS_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GSAMPLER_TYPE_DEVICE))
#define GSAMPLER_IS_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GSAMPLER_TYPE_DEVICE))
#define GSAMPLER_DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GSAMPLER_TYPE_DEVICE, GsamplerDeviceClass))
#define GSAMPLER_DEVICE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GSAMPLER_TYPE_DEVICE, GsamplerDevicePrivate))

typedef struct _GsamplerDevice GsamplerDevice;
typedef struct _GsamplerDeviceClass GsamplerDeviceClass;
typedef struct _GsamplerDevicePrivate GsamplerDevicePrivate;

struct _GsamplerDevice {
	GtkFrame parent_instance;
	GsamplerDevicePrivate * priv;
};

struct _GsamplerDeviceClass {
	GtkFrameClass parent_class;
};

struct _GsamplerDevicePrivate {
	GtkBox* top_box;
	GtkDrawingArea* draw_area;
	GtkAdjustment* param_adj;
	GtkToggleButton* active_button;
	GtkBox* pref_box;
	GtkComboBox* param_combo;
	GtkTreeView* binding_tree;
	gchar* font;
	GsamplerDeviceInfo *info;
};

GType 					gsampler_device_get_type (void) G_GNUC_CONST;
GsamplerDevice * 		gsampler_device_new (gint type);

gboolean 				gsampler_device_active (GsamplerDevice* self, gint id);
GsamplerDeviceInfo *	gsampler_device_get_info (GsamplerDevice* self);
void 					gsampler_device_update_info (GsamplerDevice* self);
gint 					gsampler_device_get_device_id (GsamplerDevice* self);
gint 					gsampler_device_get_device_type (GsamplerDevice* self);

G_END_DECLS

#endif /* _GSAMPLER_DEVICE_H_ */