/*
 * gsampler-midi-inst-dialog.h
 * Copyright (C) Lilian Monchalin 2011 <isaya07@users.sf.net>
 * 
 * gsampler is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * gsampler is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _GSAMPLER_MIDI_INST_DIALOG_H_
#define _GSAMPLER_MIDI_INST_DIALOG_H_

#include <gtk/gtk.h>

G_BEGIN_DECLS

#define GSAMPLER_TYPE_MIDI_INST_DIALOG (gsampler_midi_inst_dialog_get_type ())
#define GSAMPLER_MIDI_INST_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GSAMPLER_TYPE_MIDI_INST_DIALOG, GsamplerMidiInstDialog))
#define GSAMPLER_MIDI_INST_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GSAMPLER_TYPE_MIDI_INST_DIALOG, GsamplerMidiInstDialogClass))
#define GSAMPLER_IS_MIDI_INST_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GSAMPLER_TYPE_MIDI_INST_DIALOG))
#define GSAMPLER_IS_MIDI_INST_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GSAMPLER_TYPE_MIDI_INST_DIALOG))
#define GSAMPLER_MIDI_INST_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GSAMPLER_TYPE_MIDI_INST_DIALOG, GsamplerMidiInstDialogClass))

typedef struct _GsamplerMidiInstDialog GsamplerMidiInstDialog;
typedef struct _GsamplerMidiInstDialogClass GsamplerMidiInstDialogClass;

struct _GsamplerMidiInstDialog {
	GtkDialog parent_instance;
	GtkComboBox* engine;
	GtkFileChooserButton* file;
	GtkComboBox* inst;
	GtkComboBox* load_combo;
	GtkEntry* name_entry;
	GtkAdjustment* vol_adj;
	GtkSpinButton* bank_spin;
	GtkComboBox* prog_combo;
	gboolean edit;
	gint update;
};

struct _GsamplerMidiInstDialogClass {
	GtkDialogClass parent_class;
};

GType 					gsampler_midi_inst_dialog_get_type (void) G_GNUC_CONST;

GsamplerMidiInstDialog* gsampler_midi_inst_dialog_new (gboolean edit);
void 					gsampler_midi_inst_dialog_connect (GsamplerMidiInstDialog *self);

G_END_DECLS

#endif /* _GSAMPLER_MIDI_INST_DIALOG_H_ */